vsg: vsg::MemoryBufferPools Class Reference

vsg 1.1.13 VulkanSceneGraph library

Loading...
Searching...
No Matches
vsg::MemoryBufferPools Class Reference

`#include <MemoryBufferPools.h>`

Inheritance diagram for vsg::MemoryBufferPools:
[legend]
Collaboration diagram for vsg::MemoryBufferPools:
[legend]

## Public Types
using | DeviceMemoryOffset = std::pair<ref_ptr<DeviceMemory>, VkDeviceSize>

## Public Member Functions
| MemoryBufferPools (const std::string &name, ref_ptr< Device > in_device, const ResourceRequirements &in_resourceRequirements={})
VkDeviceSize | computeMemoryTotalAvailable () const
VkDeviceSize | computeMemoryTotalReserved () const
VkDeviceSize | computeBufferTotalAvailable () const
VkDeviceSize | computeBufferTotalReserved () const
ref_ptr< BufferInfo > | reserveBuffer (VkDeviceSize totalSize, VkDeviceSize alignment, VkBufferUsageFlags bufferUsageFlags, VkSharingMode sharingMode, VkMemoryPropertyFlags memoryProperties)
DeviceMemoryOffset | reserveMemory (VkMemoryRequirements memRequirements, VkMemoryPropertyFlags memoryProperties, void *pNextAllocInfo=nullptr)
Public Member Functions inherited from vsg::Inherit< Object, MemoryBufferPools >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T>
T * | cast ()
template<class T>
const T * | cast () const
virtual ref_ptr< Object > | clone (const CopyOp &copyop={}) const
virtual void | traverse (Visitor &)
virtual void | accept (ConstVisitor &visitor) const
virtual void | traverse (ConstVisitor &) const
virtual void | accept (RecordTraversal &visitor) const
virtual void | traverse (RecordTraversal &) const
virtual void | read (Input &input)
virtual void | write (Output &output) const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T>
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T>
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Public Attributes
std::string | name
ref_ptr< Device > | device
VkDeviceSize | minimumBufferSize = 16 * 1024 * 1024
VkDeviceSize | minimumDeviceMemorySize = 16 * 1024 * 1024

## Protected Types
using | MemoryPools = std::vector<ref_ptr<DeviceMemory>>
using | BufferPools = std::vector<ref_ptr<Buffer>>

## Protected Attributes
std::mutex | _mutex
MemoryPools | memoryPools
BufferPools | bufferPools

## Additional Inherited Members
Static Public Member Functions inherited from vsg::Inherit< Object, MemoryBufferPools >
static ref_ptr< MemoryBufferPools > | create (Args &&... args)
static ref_ptr< MemoryBufferPools > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Detailed Description

MemoryBufferPools manages a pool of vsg::DeviceMemory and vsg::Buffer that use them. Methods are provided for getting Buffer from the pool, sharing memory to make better use of device memory.

The documentation for this class was generated from the following file:

- include/vsg/vk/MemoryBufferPools.h